<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">

    <xsl:output method="html" encoding="ISO-8859-1"/>

    <xsl:param name="tkl_authenticated"/>
    <xsl:param name="root"/>
    <xsl:param name="lang"/>
    <xsl:param name="query"/>
    <xsl:param name="admin_cwd"/>
    <xsl:param name="tkl_bin"/>
    <xsl:param name="tkl_cwd"/>
    <xsl:param name="tkl_docroot"/>
    <xsl:param name="error" select="0"/>
    <xsl:param name="pop_up"/>
    <xsl:param name="pop_up_write"/>
    <xsl:param name="reload"/>
    <xsl:param name="overview"/>
    <xsl:param name="dead"/>
    <xsl:param name="stat"/>
    <xsl:param name="help"/>
    <xsl:param name="edit_schemas"/>
    
    <xsl:variable name="path" select="concat($tkl_docroot, '/', $tkl_cwd)"/>
    <xsl:variable name="title" select="document('tkl-file://index.tkl')/portal/title"/>
    <xsl:variable name="tkl_suffix" select="string('.tkl')"/>
    <xsl:variable name="this_user" select="document('tkl-user:')"/>
    <xsl:variable name="quote">'</xsl:variable>
    <xsl:variable name="onclick" select="concat('window.open(', $quote, $quote, ',', $quote, 'xform', $quote, ',', $quote, 'width=760,height=600,screenX=1,screenY=1,top=1,left=1,resizable=yes,scrollbars=1,scrolling=yes', $quote, ')')"/>
    <xsl:variable name="xml_editor">xform2.php</xsl:variable>
    <xsl:variable name="process_script">handle_call.php</xsl:variable>
    <xsl:variable name="prop_script">prop.php</xsl:variable>
    <xsl:variable name="schema_edit">schema-editor2.php</xsl:variable>
    <xsl:variable name="amp">&amp;</xsl:variable>

<xsl:template name="main-page">
  <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
        <title>Administration - <xsl:value-of select="$title"/> - <xsl:value-of select="$this_user/tkl-user/name"/></title>
        <link rel="stylesheet" type="text/css" href="{$tkl_bin}/admin/admin.css" />
        <link rel="author" href="http://www.indexdata.dk" />
	  <script type="text/javascript">
	    <xsl:text disable-output-escaping="yes">
	      <![CDATA[
                
		function prompt_newdir (text) {
		    dirname = prompt(text, "");
		    if (dirname == null) {
			return;
		    } else {
			document.admin_main.new_dir.value = dirname;
			document.admin_main.action.value = 'directory';
			document.admin_main.submit();
		    }
		}

		function prompt_delfile (text, file) {
		    if (confirm(text)) {
		    }
		}

		function prompt_deldir (text, path) {
		    if (confirm(text)) {
			document.admin_main.del_dir.value = path;
			document.admin_main.action.value = 'directory';
			document.admin_main.submit();
		    }
		}

		function prompt_mvdir (text, old_dir) {
		    new_dir = prompt(text, "");
		    if (new_dir == null) {
			return;
		    } else {
			document.admin_main.mv_dir_old.value = old_dir;
			document.admin_main.mv_dir_new.value = new_dir;
			document.admin_main.action.value = 'directory';
			document.admin_main.submit();
		    }
		}

		function popup_error (text) {
		    alert(text);
		}

		function small_window (script) {
		    window.open(script, 'autoindex', 'width=550,height=350,screenX=1,screenY=1,top=1,left=1,resizable=yes,scrollbars=1,scrolling=yes');
		}

		function pop_up_win (script) {
		    window.open(script, 'autoindex', 'width=760,height=600,screenX=1,screenY=1,top=1,left=1,resizable=yes,scrollbars=1,scrolling=yes');
		}
				    
	      ]]>
	    </xsl:text>
	  </script>
    </head>
    <body>
      <xsl:attribute name="onLoad">
        <xsl:choose>
	  <xsl:when test="string-length($pop_up_write) &gt; 0">
	    <xsl:choose>
	      <xsl:when test="document(concat('tkl-file-exists:?file=', $pop_up_write))/tkl-file-exists/exists = 0">pop_up_win('<xsl:value-of select="concat($tkl_bin, '/', $xml_editor, '?schema=', $pop_up, '&amp;admin_lang=', $lang, '&amp;cwd=', $tkl_cwd, '&amp;write_file=', $pop_up_write)"/>')</xsl:when>
	    </xsl:choose>
	  </xsl:when>
	</xsl:choose>
      </xsl:attribute>
      <form name="admin_main" method="get" action="{concat($tkl_bin, '/', $process_script)}">
        <input type="hidden" name="cwd" value="{$tkl_cwd}"/>
        <input type="hidden" name="action" value=""/>
	<input type="hidden" name="new_dir" value=""/>
	<input type="hidden" name="del_dir" value=""/>
	<input type="hidden" name="mv_dir_old" value=""/>
	<input type="hidden" name="mv_dir_new" value=""/>
      </form>
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
	  <td width="50%" style="font: bold 18px verdana, arial, helvetica, sans-serif; color: #da7600;">
	    <xsl:value-of select="/admin/title"/>
	  </td>
	  <xsl:call-template name="menu"/>
	</tr>
	<tr>
	  <td colspan="6" style="border-bottom: 1px solid #627792;">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="6" height="25" valign="bottom">
	    <b><span xml:lang="da">Sti</span><span xml:lang="en">Path</span></b>
	  </td>
	</tr>
	<tr>
	  <td colspan="6" height="16" style="color: #da7600;" valign="bottom">
	    <xsl:call-template name="insert-path"/>
	  </td>
	</tr>
	<tr>
	  <td class="void" colspan="6" height="8" style="border-bottom: 1px solid #627792;">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="6" class="void" height="10">&#xa0;</td>
	</tr>
	<xsl:choose>
	  <xsl:when test="string-length($edit_schemas)">
	    <xsl:call-template name="insert-schemas"/>
	  </xsl:when>
	  <xsl:when test="string-length($dead)">
	    <xsl:call-template name="insert-dead"/>
	  </xsl:when>
	  <xsl:otherwise>
	    <xsl:call-template name="insert-overview"/>
	  </xsl:otherwise>
	</xsl:choose>
	<tr>
	  <td class="void" colspan="6" height="20" style="border-bottom: 1px solid #627792;">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="6" align="center"><xsl:value-of select="$this_user/tkl-user/name"/></td>
	</tr>
      </table>
    </body>
  </html>
</xsl:template>

<xsl:template name="insert-dead">
  <tr>
    <td colspan="6">
      <b><span xml:lang="da">Dde links</span><span xml:lang="en">Dead links</span>:</b>
    </td>
  </tr>
  <tr>
    <td colspan="6">&#xa0;</td>
  </tr>
  <xsl:variable name="dead_exists" select="document('tkl-find:?path=badurls.tkl&amp;level=1')/tkl-find"/>
  <xsl:choose>
    <xsl:when test="$dead_exists/file/@path">
      <xsl:variable name="dead" select="document('tkl-file://badurls.tkl')"/>
      <tr>
        <td><b>URL</b></td>
	<td colspan="2"><b><span xml:lang="da">Fejlkode</span><span xml:lang="en">Error code</span></b></td>
	<td><b><span xml:lang="da">Sidst checket</span><span xml:lang="en">Last checked</span></b></td>
	<td align="center"><b># check</b></td>
      </tr>
      <tr>
        <td>&#xa0;</td>
      </tr>
      <xsl:for-each select="$dead/badurls/BADURL">
        <tr>
          <xsl:attribute name="class">
	    <xsl:choose>
	      <xsl:when test="position() mod 2 = 1">dark</xsl:when>
	      <xsl:when test="position() mod 2 = 0">light</xsl:when>
	    </xsl:choose>
	  </xsl:attribute>
	  <td><a href="{URL}" target="_blank"><xsl:value-of select="URL"/></a></td>
	  <td colspan="2"><xsl:value-of select="ERRORCODE"/></td>
	  <td><xsl:value-of select="CHECKEDLAST"/></td>
	  <td align="center"><xsl:value-of select="CHECKEDNUMBER"/></td>
	  <td align="center">
	    <a href="{$tkl_bin}/{$xml_editor}?xml_file={FILENAME}" target="_blank">
	      <span xml:lang="da">Ret</span>
	      <span xml:lang="en">Edit</span>
	    </a>
	  </td>
	</tr>
      </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
      <tr>
        <td colspan="4">
	  <span xml:lang="da">Ingen oplysninger om dde links (badurls.tkl)</span>
	  <span xml:lang="en">No information about dead links (badurls.tkl)</span>
	</td>
      </tr>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="insert-todo">
  Under construction
</xsl:template>

<xsl:template name="insert-schemas">
  <tr>
    <td colspan="4"><b>
      <span xml:lang="da">XML schemaer</span>
      <span xml:lang="en">XML schemas</span>
    </b></td>
    <td colspan="2" align="right">
      <a href="{concat($tkl_bin, '/', $schema_edit, '?cwd=', $tkl_cwd, '&amp;filename=', $tkl_docroot, $root, '/schemas/')">
        <span xml:lang="da">Tilfj schema</span>
	<span xml:lang="en">Add schema</span>
      </a>
    </td>
  </tr>
  <tr>
    <td colspan="6" class="void" height="10">&#xa0;</td>
  </tr>
  <xsl:variable name="xsd_files" select="document('tkl-find:?path=/schemas/*.xsd&amp;level=1')/tkl-find"/>
  <xsl:for-each select="$xsd_files/file">
    <tr>
      <xsl:attribute name="class">
        <xsl:choose>
	  <xsl:when test="position() mod 2 = 1">dark</xsl:when>
	  <xsl:when test="position() mod 2 = 0">light</xsl:when>
	</xsl:choose>
      </xsl:attribute>
      <xsl:variable name="xsd_file" select="substring-after(@path, 'schemas/')"/>
      <xsl:variable name="show_xsd" select="substring-before($xsd_file, '.xsd')"/>
      <td colspan="4"><xsl:value-of select="$show_xsd"/></td>
      <td>
        <a href="{concat($tkl_bin, '/', $schema_edit, '?cwd=', $tkl_cwd, '&amp;filename=', $tkl_docroot, $root, '/schemas/', $xsd_file)}">
	  <span xml:lang="da">Ret</span>
	  <span xml:lang="en">Edit</span>
	</a>
      </td>
      <td>
        <a href="#">
	  <span xml:lang="da">Slet</span>
	  <span xml:lang="en">Delete</span>
	</a>
      </td>
    </tr>
  </xsl:for-each>
</xsl:template>

<xsl:template name="insert-overview">
	<tr>
	  <td colspan="4">
	    <b>
	    <span xml:lang="da">Underkataloger i dette katalog</span>
	    <span xml:lang="en">Sub-directories in this directory</span>
	    :</b>
	  </td>
	  <td colspan="2" align="right">
	    <xsl:choose>
	      <xsl:when test="document(concat('tkl-grant://?type=create&amp;file=', $tkl_cwd))/tkl-grant/granted = 1">
	        <xsl:variable name="prompt_text">
		  <span xml:lang="da">Angiv katalognavn:</span>
		  <span xml:lang="en">Enter directory name:</span>
		</xsl:variable>
	        <a href="#" onClick="return prompt_newdir('{$prompt_text}')">
		  <span xml:lang="da"><img src="{$tkl_bin}/grafik/button_opret_underkatalog.gif" width="132" height="19" style="border: 0px;" alt="Opret underkatalog"/></span>
		  <span xml:lang="en"><img src="{$tkl_bin}/grafik/button_create_directory.gif" width="120" height="19" style="border: 0px;" alt="Create directory"/></span>
		</a>
	      </xsl:when>
	      <xsl:otherwise>
	        <span xml:lang="da"><img src="{$tkl_bin}/grafik/button_opret_underkatalog_off.gif" width="132" height="19" style="border: 0px;"/></span>
		<span xml:lang="en"><img src="{$tkl_bin}/grafik/button_create_directory_off.gif" width="132" height="19" style="border: 0px;"/></span>
	      </xsl:otherwise>
	    </xsl:choose>
	  </td>
	</tr>
	<tr>
	  <td colspan="6" class="void" height="10">&#xa0;</td>
	</tr>
	<xsl:variable name="subdirs" select="document('tkl-find:?path=*&amp;level=1&amp;show_index=1')"/>
	<xsl:call-template name="insert-sub-dirs">
	  <xsl:with-param name="subdirs" select="$subdirs"/>
	</xsl:call-template>
	<tr>
	  <td class="void" colspan="6" height="8" style="border-bottom: 1px solid #627792;">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="6" class="void" height="10">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="6">
	    <b>
	    <span xml:lang="da">Dokumenter</span>
	    <span xml:lang="en">Documents</span>
	    :</b>
	  </td>
	</tr>
	<xsl:call-template name="insert-documents">
	  <xsl:with-param name="subdirs" select="$subdirs"/>
	</xsl:call-template>
</xsl:template>


<xsl:template name="insert-sub-dirs">
  <xsl:param name="subdirs"/>
  <xsl:variable name="deldir_text">
    <span xml:lang="da">Er du sikker p, at du vil slette kataloget?</span>
    <span xml:lang="en">Are you sure you want to delete directory?</span>
  </xsl:variable>
  <xsl:variable name="mvdir_text">
    <span xml:lang="da">Angiv nyt katalognavn, - hvis du vil flytte kataloget til en anden sti i portalen, s angiv \<xsl:value-of select="$quote"/>/ny/sti/til/katalog\<xsl:value-of select="$quote"/></span>
    <span xml:lang="en">Enter new directory name - if you intend to move the directory to another position within this portal, enter \<xsl:value-of select="$quote"/>/new/path/to/directory\<xsl:value-of select="$quote"/></span>
  </xsl:variable>
  <xsl:variable name="del_link">
    <span xml:lang="da">Slet</span><span xml:lang="en">Delete</span>
  </xsl:variable>
  <xsl:variable name="mv_link">
    <span xml:lang="da">Omdb</span><span xml:lang="en">Rename</span>
  </xsl:variable>

  <xsl:for-each select="$subdirs/tkl-find/dir">
    <xsl:sort select="translate(@path, 'abcdefghijklmnopqrstuvwxyz', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
    <xsl:variable name="dirname" select="substring-after(@path, './')"/>
    <xsl:variable name="test" select="document(concat(
                'tkl-find:?path=', $dirname, '&amp;mask=index.tkl&amp;level=1&amp;select=title'))"/>
    <tr>
      <xsl:attribute name="class">
        <xsl:choose>
	  <xsl:when test="position() mod 2 = 1">dark</xsl:when>
	  <xsl:when test="position() mod 2 = 0">light</xsl:when>
	</xsl:choose>
      </xsl:attribute>
      <xsl:variable name="rel_path" select="concat($tkl_cwd, '/', $dirname)"/>
      <td colspan="4"><a href="{$tkl_bin}/shell.php?cwd={$rel_path}&amp;admin=1">
        <xsl:value-of select="substring-before($dirname, '/')"/>&#xa0;-&#xa0;
        "<xsl:choose>
	  <xsl:when test="$test/tkl-find/dir/file[1]">
	    <xsl:value-of select="$test/tkl-find/dir/file[1]/title"/>
	  </xsl:when>
	  <xsl:otherwise>
	    <span xml:lang="da">Ingen titel</span><span xml:lang="en">No title</span>
	  </xsl:otherwise>
	</xsl:choose>"
      </a></td>
      <td>
        <xsl:choose>
	  <xsl:when test="document(concat('tkl-grant://?type=write&amp;file=', $tkl_cwd))/tkl-grant/granted = 1">
	    <a href="#" onClick="return prompt_deldir('{$deldir_text}', '{$dirname}')"><xsl:copy-of select="$del_link"/></a>
	  </xsl:when>
	  <xsl:otherwise>
	    <xsl:copy-of select="$del_link"/>
	  </xsl:otherwise>
	</xsl:choose>
      </td>
      <td>
        <xsl:choose>
	  <xsl:when test="document(concat('tkl-grant://?type=write&amp;file=', $tkl_cwd))/tkl-grant/granted = 1">
	    <a href="#" onClick="return prompt_mvdir('{$mvdir_text}', '{$dirname}')"><xsl:copy-of select="$mv_link"/></a>
	  </xsl:when>
	  <xsl:otherwise>
	    <xsl:copy-of select="$mv_link"/>
	  </xsl:otherwise>
	</xsl:choose>
      </td>
    </tr>
  </xsl:for-each>
</xsl:template>


<xsl:template name="insert-documents">
  <xsl:param name="subdirs"/>
  <xsl:variable name="allowed_schema">
    <allowSchema schema="directory.xsd">
      <fileNaming>fixedName</fileNaming>
      <nameMask>directory.tkl</nameMask>
    </allowSchema>
  </xsl:variable>
  <xsl:variable name="dir_config" select="/admin/admin_config/dir_config"/>
  <xsl:variable name="directory" select="document(concat('tkl-file:', $dir_config, 'directory.tkl'))/directory"/>
  <xsl:variable name="sorted_dir">
    <xsl:for-each select="$directory/allowSchema">
      <xsl:sort select="@schema"/>
      <xsl:copy-of select="."/>
    </xsl:for-each>
    <xsl:if test="not($directory/allowSchema[@schema='directory.xsd'])"> <!-- Allow directory.xsd if not already there -->
      <xsl:copy-of select="$allowed_schema"/>
    </xsl:if>
  </xsl:variable>
  <xsl:variable name="filtered_dir">
    <xsl:for-each select="$sorted_dir/allowSchema">
      <xsl:if test="not(preceding-sibling::allowSchema[1]/@schema = @schema)">
        <xsl:copy-of select="."/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
  <xsl:for-each select="$filtered_dir/allowSchema">
    <xsl:variable name="naming" select="document(concat('tkl-unique://?format=', translate(nameMask, '#', '%'), '&amp;type=', fileNaming, '&amp;dummy=', position()))/tkl-unique"/>
    <xsl:variable name="this_schema" select="substring-before(@schema, '.xsd')"/>
    <tr>
      <td colspan="6" class="void" height="25">&#xa0;</td>
    </tr>
    <tr>
      <td colspan="4">
        <b><xsl:value-of select="$this_schema"/></b>
      </td>
      <td colspan="2" align="right">
        <xsl:choose>
	  <xsl:when test="document(concat('tkl-grant://?type=create&amp;file=', $tkl_cwd))/tkl-grant/granted = 1 and not($naming/exists = 1)">
	    <xsl:variable name="schema_path" select="document(concat('tkl-default://?path=schemas/', @schema))/tkl-default"/>
	    <a href="{concat($tkl_bin, '/', $xml_editor, '?schema=', $schema_path/abs_path, '&amp;admin_lang=', $lang, '&amp;write_file=', $path, '/', $naming/unique, '&amp;cwd=', $tkl_cwd, '&amp;file_spec=', $naming/file_spec)}" onClick="{$onclick}" target="xform">
	      <span xml:lang="da"><img src="{$tkl_bin}/grafik/button_opret_dokument.gif" width="120" height="19" style="border: 0px;" alt="Opret dokument" /></span>
	      <span xml:lang="en"><img src="{$tkl_bin}/grafik/button_create_document.gif" width="120" height="19" style="border: 0px;" alt="Create document" /></span>
	    </a>
	  </xsl:when>
	  <xsl:otherwise>
	    <span xml:lang="da"><img src="{$tkl_bin}/grafik/button_opret_dokument_off.gif" width="120" height="19" style="border: 0px;" alt="Opret dokument" /></span>
	    <span xml:lang="en"><img src="{$tkl_bin}/grafik/button_create_document_off.gif" width="120" height="19" style="border: 0px;" alt="Create document" /></span>
	  </xsl:otherwise>
	</xsl:choose>
      </td>
    </tr>
    <tr>
      <td colspan="6" class="void" height="10">&#xa0;</td>
    </tr>
    <xsl:variable name="docs" select="$subdirs/tkl-find/file[name(document(concat('tkl-file:', substring-after(@path, './')))/*) = $this_schema and substring-after(substring-after(@path, './'), '.') = 'tkl']"/>
    <xsl:for-each select="$docs">
      <xsl:variable name="tkl_file" select="substring-after(@path, './')"/>
      <xsl:variable name="tkl_doc" select="document(concat('tkl-file:', $tkl_file))"/>
      <xsl:call-template name="insert-tkl-file">
        <xsl:with-param name="tkl_doc" select="$tkl_doc"/>
	<xsl:with-param name="tkl_file" select="$tkl_file"/>
	<xsl:with-param name="class">
	  <xsl:choose>
	    <xsl:when test="position() mod 2 = 1">dark</xsl:when>
	    <xsl:when test="position() mod 2 = 0">light</xsl:when>
	  </xsl:choose>
	</xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
    <xsl:if test="not($docs)">
      <tr class="dark">
        <td colspan="6">
	  <span xml:lang="da">Ingen dokumenter</span>
	  <span xml:lang="en">No documents</span>
	</td>
      </tr>
    </xsl:if>
  </xsl:for-each>
</xsl:template>


<xsl:template name="insert-tkl-file">
  <xsl:param name="tkl_doc"/>
  <xsl:param name="class" select="light"/>
  <xsl:param name="tkl_file"/>
  <xsl:variable name="edit">
    <span xml:lang="da">Ret</span><span xml:lang="en">Edit</span>
  </xsl:variable>
  <xsl:variable name="prop">
    <span xml:lang="da">Egenskaber</span><span xml:lang="en">Properties</span>
  </xsl:variable>
  
  <tr class="{$class}">
    <td colspan="4">
      <xsl:choose>
        <xsl:when test="$tkl_doc/*/title"><xsl:value-of select="$tkl_doc/*/title"/></xsl:when>
        <xsl:otherwise><xsl:value-of select="$tkl_file"/></xsl:otherwise>
      </xsl:choose>
    </td>
    <td>
      <xsl:choose>
        <xsl:when test="document(concat('tkl-grant://?type=read&amp;file=', $tkl_file))/tkl-grant/granted = 1">
	  <a href="{concat($tkl_bin, '/', $xml_editor, '?xml_file=', $path, '/', $tkl_file, '&amp;admin_lang=', $lang, '&amp;local_xsd_path=&amp;cwd=', $tkl_cwd)}" onClick="{$onclick}" target="xform">
	    <xsl:copy-of select="$edit"/>
	  </a>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:copy-of select="$edit"/>
	</xsl:otherwise>
      </xsl:choose>
    </td>
    <td>
      <xsl:choose>
        <xsl:when test="document(concat('tkl-grant://?type=write&amp;file=', $tkl_file))/tkl-grant/granted = 1">
	  <a href="javascript:small_window('{concat($tkl_bin, '/', $prop_script, '?file=', $tkl_file, '&amp;cwd=', $tkl_cwd)}')"><xsl:copy-of select="$prop"/></a>
	</xsl:when>
	<xsl:otherwise>
	  <xsl:copy-of select="$prop"/>
	</xsl:otherwise>
      </xsl:choose>
    </td>
  </tr>
</xsl:template>
  

<!-- produces path of "breadcrumbs" back to the root -->
<xsl:template name="insert-path">
    <xsl:variable name="path" select="document('tkl-path://?select=title&amp;no_index=1')/tkl-path"/>
    <xsl:for-each select="$path/step">
      <xsl:choose>
      <xsl:when test="following-sibling::step">
        <xsl:variable name="rel_path" select="concat($tkl_cwd, '/' , substring-after(@path, './'))"/>
	<a href="{$tkl_bin}/shell.php?cwd={$rel_path}&amp;admin=1">
	  <xsl:variable name="file_title" select="title"/>
	  <xsl:choose>
	    <xsl:when test="string-length($file_title) &gt; 0"><xsl:value-of select="$file_title"/></xsl:when>
	    <xsl:otherwise>
	      <span xml:lang="da">Ingen titel</span><span xml:lang="en">No title</span>
	    </xsl:otherwise>
	  </xsl:choose>
	</a>&#xa0;&gt;&#xa0;
      </xsl:when>
      <xsl:otherwise>
	<span style="color: #000000;"><xsl:value-of select="."/></span>
      </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
</xsl:template>


<xsl:template name="menu">
    <xsl:for-each select="/*/menuitem">
      <td width="10%" align="center"><b>
        <a href="{$root}?admin=1&amp;cwd={$tkl_cwd}&amp;{@path}" class="top"><xsl:value-of select="."/></a>
      </b></td>
    </xsl:for-each>
</xsl:template>


<xsl:template match="admin">
    <xsl:call-template name="main-page"/>
</xsl:template>


<xsl:template name="main-body">
    <xsl:variable name="subjects" select="document(concat('tkl-find://',
        '?path=links/*',
	'&amp;mask=index.tkl',
	'&amp;select=title',
	'&amp;level=2'))"/>

    <xsl:for-each select="$subjects/*/dir">
        <xsl:sort select="@path"/>
        <p/>
	<b><a href="{@path}"><xsl:value-of select="file"/></a></b>
	<br/>
	<xsl:for-each select="dir">
	    <xsl:sort select="@path"/>
	    <a href="{file/@path}"><xsl:value-of select="file"/></a>
	    <br/>
	</xsl:for-each>
    </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
