<?php

// Copyright (c) 2002-2003, Index Data.
// $Id: xform.php,v 1.76 2003/06/10 12:38:11 adam Exp $

require "config.php";
require "standards.php";
require "domtools.php";
require "search.php";
require "xform_valid.php";

if (!$cwd && $xml_file) { // Infer cwd from file path
    $docroot = $_SERVER['DOCUMENT_ROOT'];
    $cwd = '//' . preg_replace("'^$docroot/(.*)/[^/]*$'", '\1', $xml_file);
}

find_portal_root();
$this_user = check_auth_user();
$style_indent = 0;
$max_indent = 0;
//$debug = 1;
if (strlen($url)) {
    $xml_raw = get_metadata($url);
}

if (strlen($choose_dir)) {			// If $choose_dir is set, change cwd to the new place...
    $cwd = "$doc_root/$choose_dir";
    find_portal_root();
    $this_user = check_auth_user();
    $choose_dir = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$choose_dir";
}

if (is_granted($cwd, "write") && ( ($xml_file && is_granted($xml_file, "write")) || 
    				   ($write_file && is_granted($write_file, "write")) ||
				   ($write && $choose_dir && is_granted("$choose_dir$write", "write")) ) ) {
    $allow_write = 1;
    if (strlen($choose_dir) && !strlen($write_file)) {
	$write_file = $choose_dir;
    }
} elseif ($url) {
    $allow_write = 1;
    $file_spec = 1;		// So far, we always allow user to specify file name
} else {
    echo "<b>Skriveadgang ngtet</b><br>";
    $save = 0;			// Never save anything, if we're not allowed to...
}

if ($xml_file) {
    if (!is_granted($xml_file, "read")) {
	exception("You're not allowed to open this file: '$xml_file'");
	die;
    }
}

$typemap = array(	// These objects constitutes our basic building blocks, somehow...
			'xs:string'     	=>      'text',
			'xs:date'       	=>      'text',
			'xs:integer'    	=>      'text',
			'xs:decimal'		=>	'text',
			'xs:positiveInteger'	=>	'text',
			'xs:boolean'		=>	'text',
			'xs:anyURI'		=>	'text',
			'xs:anyType'		=>	'text',
		);

if ($xml_file || $xml_raw) {	// If we have an xml-file we want to load and parse it...
    if ($xml_raw) {
	if (!($dom_xml = domxml_open_mem($xml_raw))) {
	    echo "Can't open/parse raw xml<br><pre>", htmlentities($xml_raw), "</pre>\n";
	    die;
	}
    } elseif (!($dom_xml = domxml_open_file($xml_file))) {
	echo "Can't open/parse xml file '$xml_file'";
	die;
    }
    $doc = $dom_xml->document_element();
    $doc_elem = $doc->tagname();
    $schemaname = "$doc_elem.xsd";
    if (file_exists($xsd_cand = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$xsd_path/$schemaname")) {
	$schema = $xsd_cand;
    } else {
	$schema = "$xsd_path/$schemaname";
    }

    if (!@file_exists($schema)) {
	echo "<b>Du kan ikke editere i denne post.</b>";
	die;
    }
    if (!($dom_schema = domxml_open_file($schema))) {
	echo "Unable to construct DOM object";
	die;
    }
    create_struct($f = array(), $dom_xml->document_element());
}


if (!strlen($write_file)) {
    $write_file = $xml_file;
}

if (is_array($f)) {		// Check structure of $f, add info about schema and render xml...
    if (count($f) > 1) {
	exception("No more than one root tag");
    }
    if (list($field, $content) = each($f)) {
	if (count($content) > 1) {
	    exception("Root tag must only occur once");
	}
	if ($debug) {
	    echo "Root tag is '$field'<br>";
	}
	if (!$start) {		// If we have no start tag given, use the root tag as start tag
	    $start = $field;
	}
	if (list($offset, $value) = each($content)) {
	    if (!strlen($creator = $value['attr']['creator']['value'])) {
		$creator = $f[$field][$offset]['attr']['creator']['value'] = $this_user['login'];
	    }
	    if (!strlen($created = $value['attr']['created']['value'])) {
		$f[$field][$offset]['attr']['created']['value'] = date("Y-m-d, H:i:s", time());
	    }
	    $f[$field][$offset]['attr']['modifier']['value'] = $this_user['login'];
	    $f[$field][$offset]['attr']['modified']['value'] = date("Y-m-d, H:i:s", time());
	}
	$schema_candidate = "$field.xsd";
    }
    if ($debug) {
	echo "<pre>", htmlentities($xml_data), "</pre>";
	echo "<hr>\n";
    }
} else {
    //$f = array();
}
if ($debug) {
    echo "<pre>";
    print_r($f);
    echo "</pre><hr>";
}
if (!$schema) {
    if (!$schema_candidate) {
	echo "No schema information available";
	die;
    } else {
	$schema = $schema_candidate;
	if (file_exists($xsd_cand = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$xsd_path/$schema")) {
	    $schema = $xsd_cand;
	} else {
	    $schema = "$xsd_path/$schema";
	}
    }
}
if (!strlen($creator)) {
    $creator = $this_user['login'];
}
if (!@file_exists($schema)) {
    echo "<b>Du kan ikke editere i denne post.</b>";
    die;
}
if (!($dom_schema = domxml_open_file($schema))) {
    echo "Unable to construct DOM object";
    die;
}
$schema_root = $dom_schema->root();
if (!is_array($f)) {			// We're dealing with an empty document...
    $default_file = $schema_root->get_attribute('default_file');
    if (strlen($default_file)) {
	$abs_def_file = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$default_file";
	if (!($dom_xml = domxml_open_file($abs_def_file))) {
	    echo "Can't open/parse default xml file '$abs_def_file'";
	    die;
	}
	create_struct($f = array(), $dom_xml->document_element());
    }
}
	
    
$root_elements = dom_select_ext($schema_root, array("element"));
$no_of_elm = count($root_elements);
if ($no_of_elm != 1) {
    die("Number of root elements must be 1, the number found is $no_of_elm");
} else {
    $schema_element_root = $root_elements[0];
}


function create_namespace ($node, &$ns) {
    // We adopt the Perl namespace model, where a specific identifier can co-exist in
    // various contexts simultaneously

    if ($tag = $node->tagname) {
	if ($name = $node->get_attribute('name')) {
	    $ns[$name][$tag] = $node;
	}
    }
    if ($kids = $node->child_nodes()) {
	foreach ($kids as $kid) {
	    create_namespace($kid, $ns);
	}
    }
}


function get_value (&$f, &$path, $type="") {
    $value = get_node($f, $path);
    if ($type == "xs:anyType") {
	if ($node = $value['parent']) {
	    //$ret = "";
	    //if (is_array($kiddoz = $node->child_nodes())) {
		//foreach ($kiddoz as $child) {
		  //  $ret .= utf8_decode($child->dump_node($child));
		//}
	    //}
            //return $ret;
	    return dump_xml($node);
	} else {
	    return escape_amp(stripslashes($value['value']));
	}
    } else {
	return escape_amp(stripslashes($value['value']));
    }
}


function get_node (&$f, &$path) {
    $value = $f;
    foreach ($path as $key) {
	$value = $value[$key];
    }
    return $value;
}


function get_last(&$f, &$path, $field) {
    // Checks the sub-structure for non-empty nodes and returns the offset of last non-empty node
    
    $extended_path = array_merge($path, $field);
    $nodeset = get_node($f, $extended_path);

    if (is_array($nodeset)) {
	for ($count = count($nodeset); $count >= 0; $count--) {
	    $node = $nodeset[$count];
	    if (strlen(trim($node['value']))) {		// If the value is non-empty this qualify as last node
		return $count;
	    }
	    if (is_array($attributes = $node['attr'])) {	// Check for attributes
		foreach ($attributes as $key => $value) {
		    if (trim($key)) {
			return $count;
		    }
		}
	    }
	    if (is_array($subtree = $node['subtree'])) {	// Otherwise, check for non-empty sub-fields
		foreach ($subtree as $sub_field => $dummy) {
		    if (get_last($f, array_merge($extended_path, $count, 'subtree'), $sub_field) != -1) {
			return $count;
		    }
		}
	    }
	}
    }
    return -1;
}
		    

function get_form_name (&$path) {
    // Generates a generic path name for the specific xml node
    
    return "f" . get_path_str($path) . "[value]";
}


function get_path_str (&$path) {
    // Generates a generic path string for the specific xml node

    return "[" . join("][", $path) . "]";
}

function make_attr ($attr) {
    $ret = "";
    if (is_array($attr)) {
	foreach ($attr as $key => $value) {
	    while (is_array($value)) {
		$value = stripslashes($value['value']);
	    }
	    $ret .= " $key=\"" . escape_amp($value) . "\"";
	}
    }
    return $ret;
}


function make_info (&$info, $level) {
    // Based on the $info structure this function returns an info tag to include in the meta xml-document

    global $indent;
    if (!is_array($info)) {
	return;
    }
    $ret = str_repeat($indent, $level) . "<info>\n";
    foreach ($info as $tag => $entry) {
	$ret .= str_repeat($indent, $level + 1) . "<$tag";
	if (is_array($attributes = $entry['attr'])) {
	    $ret .= make_attr($attributes);
	}
	$ret .= ">";
	if (is_array($content = $entry['subtree'])) {
	    $ret .= "\n";
	    foreach ($content as $key => $value) {
		$value = utf8_decode($value);
		$ret .= str_repeat($indent, $level + 2) . "<$key>$value</$key>\n";
	    }
	    $ret .= str_repeat($indent, $level + 1);
	} else {
	    $content = utf8_decode($entry['content']);
	    $ret .= "$content";
	}
	$ret .= "</$tag>\n";
    }
    $ret .= str_repeat($indent, $level) . "</info>\n";

    return $ret;
}


function lang_offset ($lang) {
    global $languages, $debug;

    if ($debug) {
	echo "Looking for langauge '$lang'<br>";
    }
    foreach ($languages as $offset => $lang_info) {
	if ($lang_info['abbr'] == $lang) {
	    if ($debug) {
		echo "Found offset for language '$lang': $offset<br>";
	    }
	    return $offset;
	}
    }
    exception("Unknown language '$lang'");
}


function escape_text ($text) {
    $text = preg_replace("/</", "&lt;", $text);
    $text = preg_replace("/>/", "&gt;", $text);
    return $text;
}


function process_type ($name, $type, &$info, &$namespace, $level, &$path, $attr=array(), $node, $min, $max, $offset=-1) {
    global $style_indent, $is_invalid, $valid, $typemap, $indent, $f, $languages, $debug, $doc_root, $admin_lang;
    $ret = "";
    $hidden = "";
    $escape_field = 0;

    if ($formtype = $typemap[$type]) {			// Is this thing predeclared?
	if ($valid && ($valid_msg = element_valid ($node, $namespace, $level, $path, $type, $min, $max))) {
	    $is_invalid = 1;
	    $attr['valid'] = $valid_msg;
	    $escape_field = 1;
	}
	$ret .= str_repeat($indent, $level) . "<field name=\"$name\" path=\"" . get_form_name($path) . "\" type=\"$formtype\"" . make_attr($attr). " indent=\"$style_indent\">\n";
	if ($authoriZURL = $info['appinfo']['subtree']['authoriZURL']) {
	    if (preg_match("/.*\.tkl$/", $authoriZURL)) {
		if (!file_exists($zfn = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root$authoriZURL"))
		    die("Could not locate authority file $zfn");
		else {
		    $auth = join('', file($zfn));
		    preg_match_all("'(<enum[^>]*>.*?<\/enum>\s*)'s", $auth, $match, PREG_PATTERN_ORDER);
		    foreach ($match[1] as $enum) {
			if (preg_match("/<enum[^>]*xml:lang=\"(.*?)\"/", $enum, $match2) && $match2[1] != $admin_lang)
			    continue;
			$ret .= str_repeat($indent, $level + 1) .  "$enum\n";
		    }
		}
	    } else
		die("Fatal: Don't know how to deal with authoriZURL: $authoriZURL");
	}
	if (is_array($info)) {
	    $ret .= make_info($info, $level + 1);
	}
	if (!strlen($def_value = get_value($f, $path, $type))) {
	    $def_value = utf8_decode($node->get_attribute('default'));
	}

	$def_value = escape_text($def_value);

	if ($escape_field) {
	    $def_value = "<![CDATA[" . $def_value . "]]>";
	}
	$ret .= str_repeat($indent, $level+ 1) . "<default>" . $def_value . "</default>\n";
	if ($info['appinfo']['subtree']['langdep'] && $offset != -1) {
	    $lang_path = array_merge($path, array("attr", "xml:lang"));
	    if ($lang_code = get_node($f, array_merge($lang_path, "value"))) {
		$lang_offset = lang_offset($lang_code);
		$lang_value = get_value($f, $lang_path);
	    } else {
		$lang_offset = $offset % count($languages);
		$lang_value = $languages[$lang_offset]['abbr'];
	    }
	    $ret .= str_repeat($indent, $level + 1) . "<language>" . $languages[$lang_offset]['desc'] . "</language>\n";
	    $hidden_fields .= str_repeat($indent, $level) . "<hidden path=\"" . get_form_name($lang_path) . "\" default=\"$lang_value\"/>\n";
	}
	$ret .= str_repeat($indent, $level) . "</field>\n";
	$ret .= $hidden_fields;
    } else {
	if ($ref_node = $namespace[$type]['complexType']) {  // Otherwise, it better be in the namespace...
	    if (is_choice($ref_node)) {
		if ($attr['more']) {
		    unset($attr['more']);
		}
	    }
	    $ret .= str_repeat($indent, $level) . "<struct name=\"$name\"" . make_attr($attr) . " indent=\"$style_indent\">\n";
	    $ret .= make_info($info, $level + 1);
	    $ret .= process($ref_node, $namespace, $level + 1, $path);
	    $ret .= str_repeat($indent, $level) . "</struct>\n";
	} elseif ($ref_node = $namespace[$type]['simpleType']) {
	    $ret .= process($ref_node, $namespace, $level, $path, array('name'=>$name, 'type'=>$type, 'info'=>$info, 'attr'=>$attr));
	} else {
	    exception("Unknown type '$type' for symbol name '$name'");
	}
    }
    return $ret;
}


function ref_node ($node) {	// Keeps following referenced nodes until the base node is found...
    while ($ref = $node->get_attribute('ref')) {	// is this a reference?
	$tag = $node->tagname;
	if ($ref_node = $namespace[$ref][$tag]) {
	    if ($ref_node == $node) {
		exception("self referenced declaration '$ref' in '$tag'");
	    }
	    $node = $ref_node;
	} else {
	    exception("reference to unknown symbol '$ref' in '$tag'");
	}
    }
    return $node;
}


function element ($node, &$namespace, $level=0, &$path, $context = 0) {
    global $debug, $languages, $indent, $f, $append, $delete_node, $schema_ctx, $style_indent;
    $ret = "";
    $name = $node->get_attribute('name');	// Get as much info as possible from current node...
    $type = $node->get_attribute('type');
    $min = $node->get_attribute('minOccurs');
    $max = $node->get_attribute('maxOccurs');
    $org_node = $node;
    
    if (is_array($context)) {
	if (!strlen($min)) {
	    $min = $context['minOccurs'];
	}
	if (!strlen($max)) {
	    $max = $context['maxOccurs'];
	}
    }
    $node = ref_node($node);
    if (!$name) {					// Locally unset variables are set via the referenced object
	$name = $node->get_attribute('name');
    }
    if (!$type) {
	$type = $node->get_attribute('type');
    }
    if (!is_array($info = annotation($org_node))) {	// And likewise for annotations...
	$info = annotation($node);
    }
    if (!strlen($min)) {				// Default values for minOccurs and maxOccurs
	$min = 1;
    }
    if (!strlen($max)) {
	$max = "1";
    }
    if ($max == "unbounded") {				// Physical boundary
	$max = 9999999;
    }
    $max_offset = get_last($f, $path, $name);	// How many nodes do we already have?
    if ($info['appinfo']['subtree']['langdep']) {
	$lowest_offset = count($languages) - 1;
	if ($max_offset < $lowest_offset) {
	    $max_offset = $lowest_offset;
	}
    }
    if ($max_offset == -1) {
	$max_offset = 0;
    }
    if (isset($append) && $append == get_path_str(array_merge($path, $name))) {	// Are we going to append another field?
	if ($info['appinfo']['subtree']['langdep']) {
	    $max_offset = $max_offset + count($languages);
	} else {
	    $max_offset ++;
	}
    }
    if ($max_offset < ($min - 1)) {		// Always show at least minOccurs number of fields
	$max_offset = $min - 1;
    }
    if ($max_offset >= $max) {
	$max_offset = $max - 1;
    }

    $info_xml = make_info($info, $level + 1);
    if ($sub_node = dom_select($node, array("complexType", "simpleContent", "extension"))) {
	return $ret . extension($sub_node, $namespace, $level, $path, $info);
    }
    for ($offset = 0; $offset <= $max_offset; $offset ++) {	// Loop through node-set
	$ext_path = array_merge($path, array($name, $offset));
	if (($offset == $max_offset) && ($max_offset < ($max - 1))) {	// There are room for more elements, inform XSLT...
	    $more = array('more'=>get_path_str(array_merge($path, $name)));
	} else {
	    $more = array();
	}
	if ($max_offset > $min) {	// If we have more nodes than required, insert a delete button in XSLT...
	    $more['delete'] = get_path_str($ext_path);
	}
	if (isset($delete_node) && ($delete_node == get_path_str($ext_path))) {
	    continue;
	}
	if ($type) {						// Do we have a type?
	    $ret .= process_type($name, $type, $info, $namespace, $level, $ext_path, $more, $node, $min, $max, $offset);
	} else {						// Otherwise, the structure is a subtree...
	    if (list($sub_node) = get_elements_by_tagname($node,"simpleType")) { // SimpleType and ComplexTypes are handled differently...
		$ret .= process($sub_node, $namespace, $level, $ext_path, array('name'=>$name, 'type'=>$type, 'info'=>$info_xml, 'attr'=>$more));
	    } else {
		if (is_choice($node)) {
		    if ($more['more']) {
			unset($more['more']);
		    }
		}
		$ret .= str_repeat($indent, $level) . "<struct name=\"$name\"" . make_attr($more) . " indent=\"$style_indent\">\n" .
	            $info_xml .
	            process_subtree($node, $namespace, $level + 1, $ext_path) .
		    str_repeat($indent, $level) . "</struct>\n";
	    }
	}
    }
    return $ret;
}


function is_choice ($node) {
    $children = dom_select_ext($node, array('choice'));
    if (is_array($children)) {
	return count($children);
    } else {
	return 0;
    }
}
    
    

function complextype ($node, &$namespace, $level, &$path) {
    global $style_indent, $max_indent;

    $style_indent ++;
    if ($style_indent > $max_indent) {
	$max_indent = $style_indent;
    }
    $ext_path = array_merge($path, array("subtree"));
    $subtree_xml = process_subtree($node, $namespace, $level, $ext_path);
    $style_indent --;
    return $subtree_xml;
}


function simplecontent ($node, &$namespace, $level, &$path) {
    $reduced_path = reduce_path($path); 
    return process_subtree($node, $namespace, $level, $reduced_path);
}


function choice ($node, &$namespace, $level, &$path) {
    global $indent, $choice_path, $f;
    $min = $node->get_attribute("minOccurs");
    $max = $node->get_attribute("maxOccurs");
    $reduced_path = reduce_path($path);
    $offset = array_pop($reduced_path);
    $base_path = $reduced_path;
    $name = array_pop($reduced_path);
    $max_offset = get_last($f, $reduced_path, $name);
    if (is_array($kids = $node->child_nodes())) {			// Which children does the choice construction have?
	foreach ($kids as $kid) {
	    if (strlen($elem = $kid->tagname)) {
		if ($elem = "element") {				// Store true elements
		    $sub_elements[$kid->get_attribute('name')] = $kid;
		} else {
		    exception("Only xs:element tags are allowed as children of xs:choice");
		}
	    }
	}
	if (!is_array($sub_elements)) {					// We only support elements in a choice construction!
	    exception("Found no xs:element subtags under xs:choice");
	}
	foreach ($sub_elements as $sub_name => $element) {
	    if (get_last($f, $path, $sub_name) != -1) {			// Any elements of this type?
		$ret .= process($element, $namespace, $level, $path);	// If yes, then process them...
		if ($offset == $max_offset || $max_offset == -1) {
		    $ret .= str_repeat($indent, $level - 1) . "</struct>\n";
		    $ret .= str_repeat($indent, $level - 1) . "<struct name=\"$name\">\n";
		}
		break;
	    }
	}
	if ($offset == $max_offset || $max_offset == -1) {					// If we're looking @ last element, inform XSLT
	    if ($max_offset == -1) {
		$append_offset = 0;
	    } else {
		$append_offset = $offset + 1;
	    }
	    $append_choice_path = array_merge($reduced_path, $name, $append_offset, "subtree");
	    if (isset($choice_path)) {
		$choice_path_mod = preg_replace("/^\[/", "", $choice_path);
		$choice_path_mod = preg_replace("/\]$/", "", $choice_path_mod);
		$choice_path_array = preg_split("/\]\[/", $choice_path_mod);
		$choice_field = array_pop($choice_path_array);
		if ($choice_path == get_path_str(array_merge($append_choice_path, $choice_field))) {
		    $ret .= process($sub_elements[$choice_field], $namespace, $level, $append_choice_path);
		}
		$max_offset ++;
	    }
	    $ret .= str_repeat($indent, $level) . "<choice>\n";		// to insert a more button...
	    foreach ($sub_elements as $element) {
		if (!is_array($info = annotation($element))) {
		    $element = ref_node($element);
		    $info = annotation($element);
		}
		$sub_name = $element->get_attribute('name');
		$ret .= str_repeat($indent, $level + 1) . "<select path=\"" .
		        get_path_str(array_merge($base_path, $max_offset + 1, "subtree", $sub_name)) . "\">\n" .
		        make_info($info, $level + 2) .
		        str_repeat($indent, $level + 1) . "</select>\n";
	    }
	    $ret .= str_repeat($indent, $level) . "</choice>\n";
	}
	return $ret;
    } else {
	exception("xs:choice must have xs:element children");
    }
}


function reduce_path (&$path) {		// Consume path back to last subtree occurrence
    $reduced_path = array();
    $append = 0;
    for ($i = count($path) - 1; $i >= 0; $i--) {
	if (!$append && ($path[$i] == "subtree")) {
	    $append = 1;
	    continue;
	}
	if ($append) {
	    array_unshift($reduced_path, $path[$i]);
	}
    }

    return $reduced_path;
}


function extension ($node, &$namespace, $level, &$path, $info=0) {	// This code is tuned for the insertion of the lang attribute. It is not tested and intended for other purposes!
    global $f, $append, $called, $delete_node;
    $ret = "";
    
    if ($type = $node->get_attribute('base')) {
	$tag = "";
	$parent = $node;
	while ($tag != "element") {			// Navigate up in the hierarchy to find the named element
	    $parent = $parent->parent_node();
	    $tag = $parent->tagname;
	}
	if (!($name = $parent->get_attribute('name'))) {
	    exception("Extension tag must be embedded in a named element");
	}
	$max = $parent->get_attribute('maxOccurs');
	$min = $parent->get_attribute('minOccurs');
	if (!$info) {
	    if (!is_array($info = annotation($parent))) {     // And likewise for annotations...
		$info = annotation($node);
	    }
	}
	if (!strlen($min)) {                                // Default values for minOccurs and maxOccurs
	    $min = 1;
	}
	if (!strlen($max)) {
	    $max = "1";
	}
	if ($max == "unbounded") {                          // Physical boundary
	    $max = 9999999;
	}
	$max_offset = get_last($f, $path, $name);   // How many nodes do we already have?
	if ($max_offset == -1) {
	    $max_offset = 0;
	}
	if (isset($append) && $append == get_path_str(array_merge($path, $name))) { // Are we going to append another field?
	    $max_offset ++;
	}
	if ($max_offset < ($min - 1)) {             // Always show at least minOccurs number of fields
	    $max_offset = $min - 1;
	}
	if ($max_offset >= $max) {
	    $max_offset = $max - 1;
	}
	$info_xml = make_info($info, $level + 1);
	for ($offset = 0; $offset <= $max_offset; $offset ++) {     // Loop through node-set
	    $ext_path = array_merge($path, array($name, $offset));
	    if (($offset == $max_offset) && ($max_offset < ($max - 1))) {   // There are room for more elements, inform XSLT...
		$more = array('more'=>get_path_str(array_merge($path, $name)));
	    } else {
		$more = array();
	    }
	    if ($max_offset > $min) {	// If we have more nodes than required, insert a delete button in XSLT...
		$more['delete'] = get_path_str($ext_path);
	    }
	    if (isset($delete_node) && ($delete_node == get_path_str($ext_path))) {
		continue;
	    }
	    $ret .= process_type($name, $type, $info, $namespace, $level, $ext_path, $more, $node, $min, $max, $offset);
	    $ret .= process_subtree($node, $namespace, $level, $ext_path);
	}
	return $ret;
    } else {
	exception("There is no base attribute in extension tag");
    }
}


function simpletype ($node, &$namespace, $level, &$path, &$context) {
    global $f, $indent, $typemap, $style_indent;
    $name = $context['name'];
    $attr = $context['attr'];
    $info = $context['info'];
    
    if (list($sub_node) = get_elements_by_tagname($node,'restriction')) {
	$sub_info = restriction($sub_node, $namespace, $level, $path, $context);
    } else {
	exception("simpleType without any restriction sub tag");
    }
    $type = $typemap[$sub_info['base']];
    $enum = $sub_info['enum'];
    
    $ret .= str_repeat($indent, $level) . "<field name=\"$name\" path=\"" . get_form_name($path) . "\" type=\"$type\"" . make_attr($attr). " indent=\"$style_indent\">\n";
    $ret .= $info . $enum . str_repeat($indent, $level);
    $ret .= str_repeat($indent, $level + 1) . "<default>" . escape_text(get_value($f, $path)) . "</default>\n";
    $ret .= str_repeat($indent, $level) . "</field>\n";
    return $ret;
}


function sequence ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function maxlength ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function pattern ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function attribute ($node, &$namespace, $level, $path) { // So far, we treat attributes as elements...
    $tag = 'attribute';
    if ($ref = $node->get_attribute('ref')) {		// Is this a reference?
	if ($ref_node = $namespace[$ref][$tag]) {
	    if ($ref_node == $node) {
		exception("Self referenced declaration '$ref' in '$tag'");
	    }
	    return process($ref_node, $namespace, $level, $path);
	} else {
	    exception("Reference to unknown symbol '$ref' in '$tag'");
	}
    }
    $info = annotation($node);
    $name = $node->get_attribute('name');
    $type = $node->get_attribute('type');
    if ((string) $path[count($path) - 1] == 'subtree') {
	array_pop($path);
    }
    $ext_path = array_merge($path, array("attr", $name));
    if ($type) {                                    // Do we have a type?
	return process_type($name, $type, $info, $namespace, $level, $ext_path, array(), $node, $min, $max);	// Remember to implement $info here!!!!
    } else {
	exception("Attribute '$name' with no type");
    }
}


function restriction ($node, &$namespace, $level, &$path, $context=0) {
    $ret = array();
    if ($base = $node->get_attribute('base')) {
	$ret['base'] = $base;
    } else {
	exception("No base attribute present");
    }
    $ret['enum'] = process_subtree($node, $namespace, $level + 1, $path, $context);
    return $ret;
}


function enumeration ($node, &$namespace, $level, &$path, $context=0) {
    global $indent;
    
    if ($value = $node->get_attribute('value')) {
	return str_repeat($indent, $level) . "<enum value=\"$value\"/>\n";
    } else {
	exception("Enumeration tag without value attribute");
    }
}
    

function process ($node, &$namespace, $level=0, &$path, $context=0) {
    global $valid;
    
    if ($tag = $node->tagname) {
	if ($tag == "annotation" || $tag == "extension") {	// Annotations/extensions are handled elsewhere, neglect them here...
	    return;
	}
	if (function_exists($tag)) {
	    if (is_array($context)) {
		$result = $tag($node, $namespace, $level, $path, $context);
	    } else {
		$result = $tag($node, $namespace, $level, $path);
	    }
	    return $result;
	} else {
	    exception("Unsupported tag: '$tag'");
	}
    }
}

function annotation ($node, $found=0) {
    // Extracts the content of an annotation tag, and returns a nested associative array.
    // If there is no annotation sub-node, false is returned.
   
    if (is_array($entries = $node->child_nodes())) {
	foreach ($entries as $entry) {
	    if ($tag = $entry->tagname) {
		if ($tag != "annotation") {
		    if (!$found) {
			continue;
		    } else {
			if (is_array($sub_entries = $entry->child_nodes())) {
			    foreach ($sub_entries as $sub_entry) {
				if (($content = trim(get_content($sub_entry))) && $sub_entry->tagname) {
				    $info[$tag]['subtree'][$sub_entry->tagname] = $content;
				} elseif (trim($content)) {
				    $info[$tag]['content'] = $content; }
			    }
			}
		    }
		} else {
		    return annotation($entry, 1);
		}
	    } 
	}
	return $info;
    } else {
	return 0;
    }
}


function process_subtree ($node, &$namespace, $level, &$path, $context=0) {
    $ret = "";
    if ($kids = $node->child_nodes()) {
	foreach ($kids as $kid) {
	    $ret .= process($kid, $namespace, $level, $path, $context);
	}
    }
    return $ret;
}


function schema ($node, &$namespace, $level=0, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


$path = array();
create_namespace($schema_root, $namespace = array());

if (strlen($start)) {
    $output_xml = process($namespace[$start]['element'], $namespace, 1, $path);
} else {
    $output_xml = process($schema_element_root, $namespace, 1, $path);
}

$write_error = 0;
if ($save && is_array($f) && (!$is_invalid || $url)) {
    $xml_data = $xml_header. create_xml($f);
    if (isset($write_file)) {
	$filename = $write_file;
	if ($file_spec && strlen($write)) {
	    $filename = "$filename/$write";
	}
	if (!is_granted($filename, "write")) {
	    echo "<h1>Write access error</h1>\n";
	    die;
	    $write_error = 2;
	} elseif ($file_spec && file_exists($filename)) {
	    $write_error = 1;
	} else {
	    if (!($fh = fopen($filename, "w"))) {
		exception("Unable to open file '$filename' for writing");
	    }
	    if (!(fputs($fh, $xml_data))) {
		exception("Unable to write xml data to file '$filename'");
	    }
	    fclose($fh);
	    if ($debug) {
		echo "Wrote xml data to file '$filename'<br>";
	    }
	    $saved = 1;
	    search_index($filename);
	}
    }
}
$creator_info = get_user_info($creator);
$creator_name = $creator_info['name'];
$output_xml = $xml_header . "<xform invalid=\"$is_invalid\" saved=\"$saved\" url=\"$url\" creator_name=\"$creator_name\" creator=\"$creator\" allow_write=\"$allow_write\" cwd=\"$cwd\" write=\"$write\" write_file=\"$write_file\" schema=\"$schema\" action=\"$xml_editor\" root=\"$start\" error=\"$write_error\" file_spec=\"$file_spec\" max_indent=\"$max_indent\">\n" . $output_xml;
$output_xml .= "</xform>\n";
if ($debug) {
    echo "<pre>\n", htmlentities($output_xml), "\n</pre>\n";
}
$xslt = xslt_create();
if ($result = xslt_process($xslt, "arg:/_xml", "xform.xsl", NULL, array('/_xml' => $output_xml), array('doc_root'=>$_SERVER['DOCUMENT_ROOT'] . "/$doc_root", 'admin_lang' => $admin_lang))) {
    echo $result;
} else {
    echo sprintf("Kunne ikke hndtere XML dokument [%d]: %s", xslt_errno($xslt), xslt_error($xslt));
    die;
}
xslt_free($xslt);


// $Log: xform.php,v $
// Revision 1.76  2003/06/10 12:38:11  adam
// Dollar id in headers
//
// Revision 1.75  2003/02/04 13:23:06  sondberg
// Now we're supporting default files.
//
// Revision 1.74  2003/02/03 23:12:26  sondberg
// Added a few parameters to xslt, i.e. doc_root and admin_lang.
//
// Revision 1.73  2003/02/03 12:47:16  sondberg
// Escaping < and >.
//
// Revision 1.72  2003/02/03 09:14:12  sondberg
// Removed insert button for choice subtrees.
//
// Revision 1.71  2003/01/27 14:39:44  sondberg
// Added support for xs:choice in the schema.
//
// Revision 1.70  2003/01/13 14:25:28  sondberg
// Finally, the double slash found its way to cvs.
//
// Revision 1.69  2003/01/13 14:14:45  sondberg
// escape_amp is called for each attribute value.
//
// Revision 1.68  2003/01/13 09:23:53  sondberg
// Applied utf8_decode upon the default element attribute.
//
// Revision 1.67  2003/01/10 13:48:22  sondberg
// The function process is called with root xs:element node (to avoid ambiguity
// with respect to document element for schemas with named types).
//
// Revision 1.66  2003/01/06 13:36:13  sondberg
// xform maintains document element attributes: modifier, modified.
//
// Revision 1.65  2002/11/20 10:31:27  sondberg
// Cleaning up.
//
// Revision 1.64  2002/11/20 10:18:29  sondberg
// Added a indent attribute to struct and field elements.
//
// Revision 1.63  2002/10/16 09:23:48  sondberg
// Now the delete field buttons apply to extension fields as well
//
// Revision 1.62  2002/10/09 13:27:06  sondberg
// Replaced dump_node with my home brewed php version: dump_xml.
//
// Revision 1.61  2002/10/04 10:06:41  quinn
// Work
//
// Revision 1.60  2002/10/03 10:07:36  sondberg
// Created date format is now human readable, i.e. YYYY-MM-DD, HH:MM:SS
//
// Revision 1.59  2002/10/03 09:32:26  sondberg
// Ooops, created instead of modified.
//
// Revision 1.58  2002/10/03 08:15:58  sondberg
// Xform keeps track of a modified epoch time.
//
// Revision 1.57  2002/09/25 12:27:54  sondberg
// Implemented the default facility.
//
// Revision 1.56  2002/09/25 12:27:10  sondberg
// *** empty log message ***
//
// Revision 1.55  2002/09/13 08:53:12  adam
// Compatible DOMXML (PHP 4.1, 4.2 and 4.3 shold work)
//
// Revision 1.54  2002/09/12 14:12:10  sondberg
// Now it checks for well-formed ness, before saving.
//

?>

