<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xhtml" encoding="ISO-8859-1"/>

<xsl:param name="doc_root"/>
<xsl:param name="admin_lang"/>


<xsl:template match="xform">
  <html>
    <head>
      <title>Dokumenteditor</title>
      <script type="text/javascript">
        <xsl:text disable-output-escaping='yes'>
	<![CDATA[
	function set_append(path) {
    	    document.main.append.value = path;
    	    document.main.submit();
    	}
	function set_choice(path) {
	    document.main.choice_path.value = path;
    	    document.main.submit();
    	}
    	function set_valid(v) {
    	    document.main.valid.value = v;
    	    document.main.submit();
    	}
	function set_delete(v) {
	    document.main.delete_node.value = v;
	    document.main.submit();
	}
	function popup_editor(formid, fieldid) {
	    window.open("simple_editor.php?formid="+formid+"&fieldid="+escape(fieldid), 'popupeditor', 'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=900,height=600');
	}
	function insert_today(field, form) {
	    d = new Date();
	    yy = d.getYear();
	    var year = (yy < 1000) ? yy + 1900 : yy; 
	    month = new String(d.getMonth() + 1);
	    date = new String(d.getDate());
	    if (month.length < 2) {
		month = "0" + month;
	    }
	    if (date.length < 2) {
		date = "0" + date;
	    }
	    document[form][field].value = year + "-" + month + "-" + date;
	}
	function append_value(field, form, val) {
	    document[form][field].value += val;
	}
        function launch(feltNavn, form_name, target, field) {
            var word = new Array();
            string = document[form_name][feltNavn].value.replace(/(\ +)/g, "%20");
            word = string.split(/[;]+/);
            var length = word.length - 1;
            while ((word[length]=="") && (length>0)) {
              	length--;
            }
            var word2 = word[length];
            if (word2.indexOf("%20") == 0) {
            	word2 = word2.replace(/%20/, "");
            }
            word2 = word2.replace(/[ ]/g, "%20");
            gallery=window.open("browse.php?target="+target+"&form_name="+form_name+"&field_name="+feltNavn+"&term1="+escape(word2)+"&field1="+field+"&type="+feltNavn,"gallery",'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=305,height=390')
        }
        function launch_checkURL(feltNavn, form_name, cwd) {
            window.open("robotwrapper.php?cwd="+cwd+"&url="+document[form_name][feltNavn].value, 'urlcheck', 'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=305,height=390')
        }
    	function set_save(v) {
    	    document.main.save.value = v;
    	    document.main.valid.value = v;
    	    document.main.submit();
    	}
    	function close_win() {
    	    opener.location.reload();
    	    close();
    	}
	function dir_browse(cwd) {
	    gallery=window.open("dirbrowse.php?cwd="+cwd+"&field_name=choose_dir&form_name=main","gallery",'toolbar=0,menubar=0,status=1,scrollbars=0,SCROLLING=NO,resizable="yes",WIDTH=300,height=380');
	}
      ]]>
      </xsl:text>
      </script>
    </head>
    <body>
      <xsl:choose>
        <xsl:when test="not(@url='')">
	  <xsl:attribute name="onLoad">dir_browse('<xsl:value-of select="@cwd"/>')</xsl:attribute>
	</xsl:when>
	<xsl:when test="@saved='1'">
	  <xsl:attribute name="onLoad">close_win()</xsl:attribute>
	</xsl:when>
      </xsl:choose>
      <form name="main" method="post">
        <xsl:attribute name="action">
	  <xsl:value-of select="@action"/>
	</xsl:attribute>
	<input type="hidden">
	  <xsl:attribute name="name">append</xsl:attribute>
	  <xsl:attribute name="value"></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">write_file</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@write_file"/></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">write</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@write"/></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">schema</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@schema"/></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">cwd</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@cwd"/></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">start</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@root"/></xsl:attribute>
	</input>
	<input type="hidden">
	  <xsl:attribute name="name">file_spec</xsl:attribute>
	  <xsl:attribute name="value"><xsl:value-of select="@file_spec"/></xsl:attribute>
	</input>
	<input type="hidden" name="dir" value="0"/>
	<input type="hidden" name="valid" value="0"/>
	<input type="hidden" name="save" value="0"/>
	<input type="hidden" name="delete_node" value="0"/>
	<input type="hidden" name="choose_dir" value=""/>
	<input type="hidden" name="choice_path" value=""/>
      <table>
      <tr><td colspan="2"><xsl:call-template name="errorMsg"/></td></tr>
      <tr><td colspan="2">
        <input type="button" value="Tilbage" onClick="close_win()"/>
      </td></tr>
      <xsl:call-template name="insertSave">
        <xsl:with-param name="save_as">0</xsl:with-param>
      </xsl:call-template>
      <xsl:apply-templates/>
      <tr><td><b>Oprettet af</b></td><td><xsl:value-of select="@creator_name"/> (<xsl:value-of select="@creator"/>)</td></tr>
      <tr><td colspan="2">
        <input type="button" value="Tilbage" onClick="close_win()"/>
      </td></tr>
      <xsl:call-template name="insertSave">
        <xsl:with-param name="save_as">1</xsl:with-param>
      </xsl:call-template>
      </table>
      </form>
      <script language="JavaScript1.1">
          window.document.focus();
      </script>
    </body>
  </html>
</xsl:template>

<xsl:template name="insertChoice">
  <xsl:if test="choice">
    <tr><td><input type="button" value="Indst felt" onClick="return set_choice(document.main.selected_path.value)"/></td>
    <td><select name="selected_path">
      <xsl:for-each select="choice/select">
        <option value="{@path}"><xsl:value-of select="info/documentation/fieldname"/></option>
      </xsl:for-each>
    </select></td>
    </tr>
  </xsl:if>
</xsl:template>

<xsl:template name="insertSave">
  <xsl:param name="save_as"/>
  <xsl:choose>
    <xsl:when test="@allow_write='1'">
      <xsl:choose>
        <xsl:when test="@file_spec='1'">
	  <tr>
	    <td>
	      <input type="button" value="Gem som" onClick="return set_save(1)"/>
	    </td>
	    <td>
	      <xsl:choose>
	        <xsl:when test="$save_as='1'">
		  <input type="text" name="write">
		    <xsl:attribute name="value">
		      <xsl:value-of select="@write"/>
		    </xsl:attribute>
		  </input>
		</xsl:when>
	      </xsl:choose>
	    </td>
	  </tr>
	</xsl:when>
	<xsl:otherwise>
	  <tr>
	    <td colspan="2">
	      <input type="button" value="Gem" onClick="return set_save(1)"/>
	    </td>
	  </tr>
	</xsl:otherwise>
      </xsl:choose>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="errorMsg">
  <xsl:choose>
    <xsl:when test="@error='1'"><b>Fil eksisterer allerede</b></xsl:when>
    <xsl:when test="@error='2'"><b>Du har ikke skriveadgang i dette katalog</b></xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template match="struct">
    <tr><td colspan="2"><h1>
    <xsl:call-template name="insertFieldName"/>
    <xsl:call-template name="insertDel">
      <xsl:with-param name="text" select="'Slet undertr'"/>
    </xsl:call-template>
    <xsl:call-template name="insertMore">
      <xsl:with-param name="text" select="'Indst undertr'"/>
    </xsl:call-template>
    </h1>
    </td></tr>
    <xsl:apply-templates select="field"/>
    <xsl:apply-templates select="hidden"/>
    <tr><td colspan="2"></td></tr>
    <xsl:call-template name="insertChoice"/>
    <xsl:apply-templates select="struct"/>
</xsl:template>

<xsl:template name="inputField">
  <input type="text" size="50">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:copy-of select="default/node()"/>
    </xsl:attribute>
  </input>
  <xsl:choose>
    <xsl:when test="info/appinfo/authoriZURL">
      <a href="#" onClick="launch('{@path}','main','bagel.indexdata.dk:2200/Default','@attr 1=1016');">
        <img SRC="grafik/lup.gif" BORDER="0" WIDTH="14" HEIGHT="14" TITLE="Sl op i registret" ALT="Sl op i registret..."/>
      </a>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="hiddenField">
  <input type="hidden">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:copy-of select="default/node()"/>
    </xsl:attribute>
  </input>
  <xsl:copy-of select="default/node()"/>
</xsl:template>


<xsl:template name="passwdField">
  <input type="password" size="50">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:copy-of select="default/node()"/>
    </xsl:attribute>
  </input>
</xsl:template>

<xsl:template name="dateField">
  <input type="text" size="50">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:copy-of select="default/node()"/>
    </xsl:attribute>
  </input>
  <a href="#">
    <xsl:attribute name="onClick">
      <xsl:text>insert_today('</xsl:text>
      <xsl:value-of select="@path"/>
      <xsl:text>','main');</xsl:text>
    </xsl:attribute>
    <img SRC="grafik/dateconfig.png" BORDER="0" height="20" TITLE="Indst dags dato" ALT="Indst dags dato"/>
  </a>
</xsl:template>


<xsl:template name="urlField">
  <input type="text" size="50">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:copy-of select="default/node()"/>
    </xsl:attribute>
  </input>
  <a href="#">
    <xsl:attribute name="onClick">
      <xsl:text>launch_checkURL('</xsl:text>
      <xsl:value-of select="@path"/>
      <xsl:text>','main','</xsl:text>
      <xsl:value-of select="/xform/@cwd"/>
      <xsl:text>');</xsl:text>
    </xsl:attribute>
    <img SRC="grafik/tjekurl.gif" BORDER="0" TITLE= "Tjek om linket virker, og om det allereede eksisterer i databasen" ALT="Tjek om linket virker, og om det allerede eksisterer i databasen"/>
  </a>
</xsl:template>


<xsl:template name="selectField">
  <select>
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:for-each select="enum">
      <xsl:sort select="@value"/>
      <xsl:if test="not(@value = following-sibling::enum/@value)">
	<option value="{@value}">
	  <xsl:choose>
	    <xsl:when test="../default/node()=@value">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:when>
	  </xsl:choose>
	  <xsl:value-of select="@value"/> - <xsl:value-of select="."/>
	</option>
      </xsl:if>
    </xsl:for-each>
  </select>
</xsl:template>

<xsl:template name="checkboxField">
  <input type="checkbox" value="1">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:choose>
      <xsl:when test="default/node()='1'">
        <xsl:attribute name="checked">checked</xsl:attribute>
      </xsl:when>
    </xsl:choose>
  </input>
</xsl:template>

<xsl:template name="textareaField">
  <textarea wrap="virtual" cols="50" rows="4">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:copy-of select="default/node()"/>
  </textarea>
  <a href="#">
    <xsl:attribute name="onClick">
      <xsl:text>popup_editor('main', '</xsl:text>
      <xsl:value-of select="@path"/>
      <xsl:text>');</xsl:text>
    </xsl:attribute>
    <img SRC="grafik/lup.gif" BORDER="0" TITLE= "Rediger tekst i separat editorvindue" ALT="Rediger tekst i separat editorvindue"/>
  </a>
</xsl:template>

<xsl:template name="insertFieldName">
  <xsl:choose>
    <xsl:when test="info/documentation/fieldname">
      <xsl:value-of select="info/documentation/fieldname"/>
    </xsl:when>
    <xsl:otherwise>
      [<xsl:value-of select="@name"/>]
    </xsl:otherwise>
  </xsl:choose>
  <xsl:choose>
    <xsl:when test="language">
      (<xsl:value-of select="language"/>)
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="insertFieldDesc">
  <xsl:choose>
    <xsl:when test="info/documentation/helptext">
      <br/>
      <font size="2">
        <xsl:value-of select="info/documentation/helptext"/>
      </font>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="insertMore">
  <xsl:param name="text"/>
  <xsl:choose>
    <xsl:when test="@more">
      <input type="button">
        <xsl:attribute name="value">
          <xsl:value-of select="$text"/>
        </xsl:attribute>
        <xsl:attribute name="onClick">
    	  <xsl:text>return set_append('</xsl:text>
    	  <xsl:value-of select="@more"/>
    	  <xsl:text>')</xsl:text>
    	</xsl:attribute>
      </input>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="insertValid">
  <xsl:choose>
    <xsl:when test="@valid">
      <br/>
      <font color="FF0000" size="2">
        <xsl:value-of select="@valid"/>
      </font>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="insertDel">
  <xsl:param name="text"/>
  <xsl:choose>
    <xsl:when test="@delete">
      <input type="button">
        <xsl:attribute name="value">
	  <xsl:value-of select="$text"/>
	</xsl:attribute>
	<xsl:attribute name="onClick">
	  <xsl:text>return set_delete('</xsl:text>
	  <xsl:value-of select="@delete"/>
	  <xsl:text>')</xsl:text>
	</xsl:attribute>
      </input>
    </xsl:when>
  </xsl:choose>
</xsl:template>
	

<xsl:template name="insertSelectBox">
  <xsl:choose>
    <xsl:when test="info/appinfo/select">
      <xsl:variable name="auth_file" select="concat($doc_root, string(info/appinfo/select))"/>
        <xsl:variable name="values" select="document(concat('file://', $auth_file))"/>
	<select>
	  <xsl:attribute name="onClick">
	    <xsl:text>append_value('</xsl:text>
	    <xsl:value-of select="@path"/>
	    <xsl:text>','main', this.value);</xsl:text>
	  </xsl:attribute>
	  <xsl:for-each select="$values/authority/enum[@xml:lang=string($admin_lang)]">
	    <option value="{@value}"><xsl:value-of select="."/></option>
	  </xsl:for-each>
	</select>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template match="field">
      <tr><td>&#xa0;</td></tr>
      <tr><td valign="top"><b>
        <xsl:call-template name="insertFieldName"/>
      </b></td><td valign="top">
    <xsl:choose>
      <xsl:when test="info/appinfo/fieldtype='text'">
        <xsl:call-template name="inputField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='dropdown'">
        <xsl:call-template name="selectField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='checkbox'">
        <xsl:call-template name="checkboxField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='textarea'">
        <xsl:call-template name="textareaField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='url'">
        <xsl:call-template name="urlField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='hidden'">
        <xsl:call-template name="hiddenField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='password'">
        <xsl:call-template name="passwdField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='date'">
        <xsl:call-template name="dateField"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="inputField"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="not(info/appinfo/fieldtype='hidden')">
        <xsl:call-template name="insertSelectBox"/>
        <xsl:call-template name="insertDel">
	  <xsl:with-param name="text" select="'Slet felt'"/>
	</xsl:call-template>
	<xsl:call-template name="insertMore">
	  <xsl:with-param name="text" select="'Indst felt'"/>
	</xsl:call-template>
	<xsl:call-template name="insertValid"/>
	<xsl:call-template name="insertFieldDesc"/>
      </xsl:when>
    </xsl:choose>
  </td></tr>
</xsl:template>

<xsl:template match="hidden">
  <input type="hidden">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:value-of select="@default"/>
    </xsl:attribute>
  </input>
</xsl:template>

</xsl:stylesheet>
