<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xhtml" encoding="ISO-8859-1"/>

<xsl:param name="doc_root"/>
<xsl:param name="admin_lang"/>
<xsl:param name="domain"/>
<xsl:param name="close_win"/>
<xsl:variable name="quote">'</xsl:variable>


<xsl:template match="xform">
  <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
      <title>Editor</title>
      <link href="admin/xform.css" rel="stylesheet" type="text/css" media="screen, all" />
      <link rel="author" href="http://www.indexdata.dk" />
      <script type="text/javascript">
        <xsl:text disable-output-escaping='yes'>
	<![CDATA[
	function set_append(path) {
    	    document.main.append.value = path;
    	    document.main.submit();
    	}
	function set_moveup(path) {
    	    document.main.move_up.value = path;
    	    document.main.submit();
    	}
	function set_choice(path) {
	    document.main.choice_path.value = path;
    	    document.main.submit();
    	}
    	function set_valid(v) {
    	    document.main.valid.value = v;
    	    document.main.submit();
    	}
	function set_delete(v) {
	    document.main.delete_node.value = v;
	    document.main.submit();
	}
	function popup_editor(formid, fieldid) {
	    window.open("simple_editor.php?formid="+formid+"&fieldid="+escape(fieldid), 'popupeditor', 'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=900,height=600');
	}
	function insert_today(field, form) {
	    d = new Date();
	    yy = d.getYear();
	    var year = (yy < 1000) ? yy + 1900 : yy; 
	    month = new String(d.getMonth() + 1);
	    date = new String(d.getDate());
	    if (month.length < 2) {
		month = "0" + month;
	    }
	    if (date.length < 2) {
		date = "0" + date;
	    }
	    document[form][field].value = year + "-" + month + "-" + date;
	}
	function append_value(field, form, val) {
	    document[form][field].value += val;
	}
        function launch(feltNavn, form_name, target, field) {
            var word = new Array();
            string = document[form_name][feltNavn].value.replace(/(\ +)/g, "%20");
            word = string.split(/[;]+/);
            var length = word.length - 1;
            while ((word[length]=="") && (length>0)) {
              	length--;
            }
            var word2 = word[length];
            if (word2.indexOf("%20") == 0) {
            	word2 = word2.replace(/%20/, "");
            }
            word2 = word2.replace(/[ ]/g, "%20");
            gallery=window.open("browse.php?target="+target+"&form_name="+form_name+"&field_name="+feltNavn+"&term1="+escape(word2)+"&field1="+field+"&type="+feltNavn,"gallery",'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=305,height=390')
        }
        function launch_checkURL(feltNavn, form_name, cwd) {
            window.open("robotwrapper.php?cwd="+cwd+"&url="+document[form_name][feltNavn].value, 'urlcheck', 'toolbar=0,location=0,menubar=0,status=0,scrollbars=1,SCROLLING=yes,resizable=yes,WIDTH=305,height=390')
        }
    	function set_save(v) {
    	    document.main.save.value = v;
    	    document.main.valid.value = v;
    	    document.main.submit();
    	}
    	function close_win() {
    	    opener.location.reload();
    	    close();
    	}
	function set_close() {
	    document.main.close_win.value = 1;
	    document.main.submit();
	}
	function dir_browse(cwd) {
	    gallery=window.open("dirbrowse.php?cwd="+cwd+"&field_name=choose_dir&form_name=main","gallery",'toolbar=0,menubar=0,status=1,scrollbars=0,SCROLLING=NO,resizable="yes",WIDTH=300,height=380');
	}

	function set_focus (field_id) {
	    document.main.elements[field_id].focus();
	    window.scrollBy(0, 100);
	}
	
	function clean_up () {
	    document.main.close_win.value = 1;
	    document.main.submit();
	    close_win();
	}
      ]]>
      </xsl:text>
      </script>
    </head>
    <body>
      <xsl:choose>
        <xsl:when test="not(@url='')">
	  <xsl:attribute name="onLoad">dir_browse('<xsl:value-of select="@cwd"/>')</xsl:attribute>
	</xsl:when>
	<xsl:when test="@saved='1'">
	  <xsl:attribute name="onLoad">close_win()</xsl:attribute>
	</xsl:when>
	<xsl:when test="$close_win='1'">
	  <xsl:attribute name="onLoad">close_win()</xsl:attribute>
	</xsl:when>
	<xsl:when test="string-length(@focus) &gt; 0">
	  <xsl:attribute name="onLoad">set_focus(<xsl:value-of select="concat($quote, @focus, $quote)"/>)</xsl:attribute>
	</xsl:when>
      </xsl:choose>
      <!--
      <xsl:if test="not($close_win='1')">
        <xsl:attribute name="onUnload">clean_up()</xsl:attribute>
      </xsl:if>
      -->
      <form name="main" method="post" action="{@action}" enctype="multipart/form-data">
	<input type="hidden" name="append" value=""/>
	<input type="hidden" name="move_up" value=""/>
	<input type="hidden" name="write_file" value="{@write_file}"/>
	<input type="hidden" name="write" value="{@write}"/>
	<input type="hidden" name="schema" value="{@schema}"/>
	<input type="hidden" name="cwd" value="{@cwd}"/>
	<input type="hidden" name="start" value="{@root}"/>
	<input type="hidden" name="file_spec" value="{@file_spec}"/>
	<input type="hidden" name="dir" value="0"/>
	<input type="hidden" name="valid" value="0"/>
	<input type="hidden" name="save" value="0"/>
	<input type="hidden" name="delete_node" value="0"/>
	<input type="hidden" name="choose_dir" value=""/>
	<input type="hidden" name="choice_path" value=""/>
	<input type="hidden" name="admin_lang" value="{$admin_lang}"/>
	<input type="hidden" name="close_win" value=""/>
	
      <table border="0" cellpadding="0" cellspacing="0" width="680">
        <tr>
	  <td width="480" class="void">&#xa0;</td>
	  <td width="200" class="void">&#xa0;</td>
	</tr>
	<tr>
	  <td class="headline" align="left">
	    <xsl:choose>
	      <xsl:when test="/xform/struct/info/documentation/fieldname"><xsl:value-of select="/xform/struct/info/documentation/fieldname"/></xsl:when>
	      <xsl:otherwise>[ <xsl:value-of select="/xform/struct/@name"/> ]</xsl:otherwise>
	    </xsl:choose>
	  </td>
	  <td align="right">
	    <a href="#" onClick="set_close()"><img src="grafik/button_return_{$admin_lang}.gif" style="border: 0px;" width="68" height="22" alt="Return" /></a>
	    &#xa0;&#xa0;
	    <xsl:call-template name="insertSave">
	      <xsl:with-param name="save_as">0</xsl:with-param>
	    </xsl:call-template>
	  </td>
	</tr>
	<tr>
	  <td colspan="2" class="line" height="10">&#xa0;</td>
	</tr>
        <tr><td colspan="2"><xsl:call-template name="errorMsg"/></td></tr>
      </table>
      <table border="0" cellpadding="0" cellspacing="0" width="700">
        <tr>
	  <td width="225" class="void">&#xa0;</td>
	  <td width="480" class="void">&#xa0;</td>
	</tr>
	<xsl:apply-templates/>
	<tr>
	  <td colspan="2" height="15">&#xa0;</td>
	</tr>
	<!--<tr>
	  <td><span class="subhead">Oprettet af</span></td>
	  <td><xsl:value-of select="@creator_name"/> (<xsl:value-of select="@creator"/>)</td>
	</tr>--> 
      </table>
      <table border="0" cellpadding="0" cellspacing="0" width="680">
	<tr>
	  <td colspan="2" class="line" height="10">&#xa0;</td>
	</tr>
	<tr>
	  <td colspan="2" height="8">&#xa0;</td>
	</tr>
	<tr>
	  <td>&#xa0;</td>
	  <td align="right"><a href="#" onClick="set_close()"><img src="grafik/button_return_{$admin_lang}.gif" style="border: 0px;" width="68" height="22" alt="Return" /></a>&#xa0;&#xa0;
	    <xsl:call-template name="insertSave">
	      <xsl:with-param name="save_as">1</xsl:with-param>
	    </xsl:call-template>
	  </td>
	</tr>
      </table>
      </form>
    </body>
  </html>
</xsl:template>

<xsl:template name="insertChoice">
  <xsl:if test="choice">
    <xsl:variable name="unique" select="generate-id()"/>
    <tr>
      <td colspan="2" height="15">&#xa0;</td>
    </tr>
    <tr>
      <td>&#xa0;</td>
      <td>
        <select class="forminput" name="{$unique}">
	  <xsl:for-each select="choice/select">
	    <option value="{@path}"><xsl:value-of select="info/documentation/fieldname"/></option>
	  </xsl:for-each>
	</select>
	<a href="javascript:set_choice(document.main.{$unique}.value)">
	  <img src="grafik/icon_plus.gif" style="border: 0px; vertical-align: top;" width="13" height="13" alt="expand" />
	</a>
      </td>
    </tr>
  </xsl:if>
</xsl:template>

<xsl:template name="insertSave">
  <xsl:param name="save_as"/>
  <xsl:choose>
    <xsl:when test="@allow_write='1'">
      <xsl:choose>
        <xsl:when test="@file_spec='1'"><a href="#" onClick="return set_save(1)"><img src="grafik/button_save_{$admin_lang}.gif" style="border: 0px;" width="41" height="22" alt="Save as" /></a>
	  <xsl:choose>
	    <xsl:when test="$save_as='1'">
	      <input type="text" name="write" value="{@write}"/>
	    </xsl:when>
	  </xsl:choose>
	</xsl:when>
	<xsl:otherwise><a href="#" onClick="return set_save(1)"><img src="grafik/button_save_{$admin_lang}.gif" style="border: 0px;" width="41" height="22" alt="Save" /></a></xsl:otherwise>
      </xsl:choose>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="errorMsg">
  <xsl:choose>
    <xsl:when test="@error='1'"><b>Fil eksisterer allerede</b></xsl:when>
    <xsl:when test="@error='2'"><b>Du har ikke skriveadgang i dette katalog</b></xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template match="struct">
  <tr>
    <td colspan="2" height="15">&#xa0;</td>
  </tr>
  <tr>
    <td class="{concat('level', @indent)}">
      <xsl:call-template name="insertDel"/>
      <span class="subhead"><xsl:call-template name="insertFieldName"/></span>
    </td>
    <td>
      <xsl:call-template name="insertMore"/>
      <xsl:call-template name="insertMoveUp"/>
    </td>
  </tr>
  <!--
  <xsl:apply-templates select="field"/>
  <xsl:apply-templates select="hidden"/>
  <xsl:apply-templates select="struct"/>
  -->
  <xsl:apply-templates/>
  <xsl:call-template name="insertChoice"/>
</xsl:template>

<xsl:template match="*"/>

<xsl:template name="inputField">
  <input type="text" class="forminput" name="{@path}" value="{default/node()}"/>
  <xsl:choose>
    <xsl:when test="info/appinfo/authoriZURL">
      <a href="#" onClick="launch('{@path}','main','bagel.indexdata.dk:2200/Default','@attr 1=1016');">
        <img SRC="grafik/lup.gif" BORDER="0" WIDTH="14" HEIGHT="14" TITLE="Sl op i registret" ALT="Sl op i registret..."/>
      </a>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="hiddenField">
  <input type="hidden" name="{@path}" value="{default/node()}"/>
  <xsl:copy-of select="default/node()"/>
</xsl:template>


<xsl:template name="passwdField">
  <input type="password" class="forminput" name="{@path}" value="{default/node()}"/>
</xsl:template>

<xsl:template name="dateField">
  <input type="text" class="forminput" name="{@path}" value="{default/node()}"/>
  <a href="javascript:insert_today('{@path}', 'main')">
    <img SRC="grafik/dateconfig.png" BORDER="0" height="20" TITLE="Indst dags dato" ALT="Indst dags dato"/>
  </a>
</xsl:template>


<xsl:template name="urlField">
  <input type="text" class="forminput" name="{@path}" value="{default/node()}"/>
  <a href="javascript:launch_checkURL('{@path}', 'main', '{/xform/@cwd}')">
    <img SRC="grafik/tjekurl.gif" BORDER="0" TITLE= "Tjek om linket virker, og om det allereede eksisterer i databasen" ALT="Tjek om linket virker, og om det allerede eksisterer i databasen"/>
  </a>
</xsl:template>


<xsl:template name="selectField">
  <select class="forminput" name="{@path}">
    <xsl:for-each select="enum">
      <xsl:sort select="@value"/>
      <xsl:if test="not(@value = following-sibling::enum/@value)">
	<option value="{@value}">
	  <xsl:choose>
	    <xsl:when test="../default/node()=@value">
	      <xsl:attribute name="selected">selected</xsl:attribute>
	    </xsl:when>
	  </xsl:choose>
	  <xsl:value-of select="@value"/> - <xsl:value-of select="."/>
	</option>
      </xsl:if>
    </xsl:for-each>
  </select>
</xsl:template>

<xsl:template name="checkboxField">
  <input type="checkbox" value="1" name="{@path}">
    <xsl:choose>
      <xsl:when test="default/node()='1'">
        <xsl:attribute name="checked">checked</xsl:attribute>
      </xsl:when>
    </xsl:choose>
  </input>
</xsl:template>

<xsl:template name="textareaField">
  <textarea type="text" rows="4" class="forminput" name="{@path}">
    <xsl:copy-of select="default/node()"/>
  </textarea>
  <a href="javascript:popup_editor('main', '{@path}')">
    <img src="grafik/lup.gif" border="0" tilte="Rediger tekst i separat editorvindue" alt="Rediger tekst i separat editorvindue"/>
  </a>
</xsl:template>

<xsl:template name="insertFieldName">
  <xsl:choose>
    <xsl:when test="info/documentation/fieldname">
      <xsl:value-of select="info/documentation/fieldname"/>
    </xsl:when>
    <xsl:otherwise>
      [<xsl:value-of select="@name"/>]
    </xsl:otherwise>
  </xsl:choose>
  <xsl:choose>
    <xsl:when test="language">
      (<xsl:value-of select="language"/>)
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="insertFieldDesc">
  <xsl:choose>
    <xsl:when test="info/documentation/helptext">
      <br/>
      <span class="small"><xsl:value-of select="info/documentation/helptext"/></span>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="insertMore">
  <xsl:choose>
    <xsl:when test="@more">
      <a href="#">
        <xsl:attribute name="onClick">
	  <xsl:text>return set_append('</xsl:text>
	  <xsl:value-of select="@more"/>
	  <xsl:text>')</xsl:text>
	</xsl:attribute>
	<img src="grafik/icon_plus.gif" style="border: 0px; vertical-align: top;" width="13" height="13" alt="expand" />
      </a>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="insertMoveUp">
  <xsl:choose>
    <xsl:when test="@moveUp">
      <a href="#">
        <xsl:attribute name="onClick">
	  <xsl:text>return set_moveup('</xsl:text>
	  <xsl:value-of select="@moveUp"/>
	  <xsl:text>')</xsl:text>
	</xsl:attribute>
	<img src="grafik/prior_op.gif" style="border: 0px; vertical-align: top;" alt="Move up" />
      </a>
    </xsl:when>
  </xsl:choose>
</xsl:template>



<xsl:template name="insertValid">
  <xsl:choose>
    <xsl:when test="@valid">
      <br/>
      <font class="small_red">
        <xsl:value-of select="@valid"/>
      </font>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="insertDel">
  <xsl:choose>
    <xsl:when test="@delete">
      <a href="#">
	<xsl:attribute name="onClick">
	  <xsl:text>return set_delete('</xsl:text>
	  <xsl:value-of select="@delete"/>
	  <xsl:text>')</xsl:text>
	</xsl:attribute>
	<img src="grafik/icon_minus.gif" style="border: 0px; vertical-align: middle;" width="13" height="13" alt="Outdent" />
      </a>&#xa0;
    </xsl:when>
  </xsl:choose>
</xsl:template>
	
<xsl:template name="radiobuttonField">
  <input type="radio" value="yes" name="{@path}"> <!-- hvis den sattes -->
    <xsl:choose>
      <xsl:when test="default/node()='yes'">
        <xsl:attribute name="checked">checked</xsl:attribute>
      </xsl:when>
    </xsl:choose>
  </input> Yes
  <input type="radio" value="no" name="{@path}">
    <xsl:choose>
      <xsl:when test="default/node()='no'">
        <xsl:attribute name="checked">checked</xsl:attribute>
      </xsl:when>
    </xsl:choose>
  </input> No
</xsl:template>
																      

<xsl:template name="insertSelectBox">
  <xsl:choose>
    <xsl:when test="info/appinfo/select">
      <xsl:variable name="auth_file" select="concat($doc_root, string(info/appinfo/select))"/>
        <xsl:variable name="values" select="document(concat('file://', $auth_file))"/>
	<select>
	  <xsl:attribute name="onClick">
	    <xsl:text>append_value('</xsl:text>
	    <xsl:value-of select="@path"/>
	    <xsl:text>','main', this.value);</xsl:text>
	  </xsl:attribute>
	  <xsl:for-each select="$values/authority/enum[@xml:lang=string($admin_lang)]">
	    <option value="{@value}"><xsl:value-of select="."/></option>
	  </xsl:for-each>
	</select>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="uploadField">
  <xsl:variable name="upload" select="default/*"/>
  <xsl:choose>
    <xsl:when test="$upload/object">
      <textarea style="display:none" name="{@path}">
        <xsl:copy-of select="default/node()"/>
      </textarea>
      <xsl:choose>
        <xsl:when test="$upload/@preview">
	  <img src="http://{$domain}/{$upload/@preview}" alt="http://{$domain}{$upload/@preview}"/>
	</xsl:when>
	<xsl:otherwise>
	  <b><xsl:value-of select="$upload/object"/></b>
	</xsl:otherwise>
      </xsl:choose>
    </xsl:when>
    <xsl:otherwise>
      <input type="hidden" name="{@path}" value="unset"/>
      <input class="forminput" name="{translate(@path, '[]', ':')}" type="file"/>
      <xsl:if test="$upload/error">
        <br/><b><xsl:value-of select="$upload/error"/></b>
      </xsl:if>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="field">
  <tr>
    <td colspan="2" height="15">&#xa0;</td>
  </tr>
  <tr>
    <td class="{concat('level', @indent)}">
      <xsl:call-template name="insertDel"/>
      <span class="subhead"><xsl:call-template name="insertFieldName"/></span>
    </td>
    <td>
    <xsl:choose>
      <xsl:when test="info/appinfo/fieldtype='text'">
        <xsl:call-template name="inputField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='dropdown'">
        <xsl:call-template name="selectField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='checkbox'">
        <xsl:call-template name="checkboxField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='textarea'">
        <xsl:call-template name="textareaField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='url'">
        <xsl:call-template name="urlField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='hidden'">
        <xsl:call-template name="hiddenField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='password'">
        <xsl:call-template name="passwdField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='date'">
        <xsl:call-template name="dateField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='radiobutton'">
        <xsl:call-template name="radiobuttonField"/>
      </xsl:when>
      <xsl:when test="info/appinfo/fieldtype='upload'">
        <xsl:call-template name="uploadField"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="inputField"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="not(info/appinfo/fieldtype='hidden')">
        <xsl:call-template name="insertSelectBox"/>
	<xsl:call-template name="insertMore"/>
	<xsl:call-template name="insertMoveUp"/>
	<xsl:call-template name="insertValid"/>
	<xsl:call-template name="insertFieldDesc"/>
      </xsl:when>
    </xsl:choose>
  </td></tr>
</xsl:template>

<xsl:template match="hidden">
  <input type="hidden">
    <xsl:attribute name="name">
      <xsl:value-of select="@path"/>
    </xsl:attribute>
    <xsl:attribute name="value">
      <xsl:value-of select="@default"/>
    </xsl:attribute>
  </input>
</xsl:template>

</xsl:stylesheet>
